<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:tei="http://www.tei-c.org/ns/1.0"
    exclude-result-prefixes="#all" xmlns:xd="http://www.oxygenxml.com/ns/doc/xsl" version="2.0">
    <xd:doc scope="stylesheet">
        <xd:desc>
            <xd:p><xd:b>Created on:</xd:b> 9th July, 2012</xd:p>
            <xd:p><xd:b>Author:</xd:b> paulcaton</xd:p>
            <xd:p>Process an eREED record after it has come from the Perl script "at-code"
                conversion</xd:p>
        </xd:desc>
    </xd:doc>
    <xsl:output method="xml"/>
    
    <xsl:template match="@*|tei:*|processing-instruction()|comment()">
        <xsl:choose>
            <xsl:when test="self::tei:div[contains(@type,'_head_wrapper')]">
                <xsl:apply-templates select="tei:*|text()|processing-instruction()|comment()"/>
            </xsl:when>
            <xsl:when test="self::tei:seg[@type='REPLACE_ME_FROM_CODE_LIST']">
                <xsl:variable name="value" select="."/>
                <xsl:choose>
                    <xsl:when test="@subtype='place_name'">
                        <placeName xmlns="http://www.tei-c.org/ns/1.0">
                            <xsl:value-of select="document('record_head_code_list.xml')//tei:list[@n='records_div']/descendant::tei:abbr[text()=$value]/following-sibling::tei:expan"/>
                        </placeName>
                    </xsl:when>
                    <xsl:when test="@subtype='source_info'">
                        <xsl:copy-of copy-namespaces="no" select="document('record_head_code_list.xml')//tei:list[@n='documents']/descendant::tei:abbr[text()=$value]/following-sibling::tei:expan/child::tei:*"/>
                    </xsl:when>
                </xsl:choose>
            </xsl:when>
            <xsl:otherwise>
                <xsl:copy>
                    <xsl:apply-templates select="tei:*|@*|text()|processing-instruction()|comment()"/>
                </xsl:copy>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>

</xsl:stylesheet>
