<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:tei="http://www.tei-c.org/ns/1.0"
    exclude-result-prefixes="#all" xmlns:xd="http://www.oxygenxml.com/ns/doc/xsl" version="2.0">
    <xd:doc scope="stylesheet">
        <xd:desc>
            <xd:p><xd:b>Created on:</xd:b> 9th July, 2012</xd:p>
            <xd:p><xd:b>Author:</xd:b> paulcaton</xd:p>
            <xd:p>Process an eREED record after it has come from the Perl script "at-code"
                conversion</xd:p>
        </xd:desc>
    </xd:doc>
    <xsl:output method="xml"/>
    
    <xsl:template match="@*|tei:*|processing-instruction()|comment()">
        <xsl:choose>
        <xsl:when test="self::tei:note">
            <xsl:variable name="record_num"><xsl:number level="single" format="01" select="ancestor::tei:text[1]"/></xsl:variable>
                <xsl:choose>
                    <xsl:when test="@type='collation'">
                        <xsl:variable name="coll_note_num"><xsl:number level="any" format="01"/></xsl:variable>
                        <xsl:copy>
                            <xsl:attribute name="xml:id">
                                <xsl:value-of select="concat('rec', $record_num, '_cn', $coll_note_num)"/>
                            </xsl:attribute>
                            <xsl:attribute name="type">collation</xsl:attribute>
                            <xsl:apply-templates/>
                        </xsl:copy>
                    </xsl:when>
                    <xsl:when test="@type='foot'">
                        <xsl:variable name="foot_note_num"><xsl:number level="any" format="01"/></xsl:variable>
                        <xsl:copy>
                            <xsl:attribute name="xml:id">
                                <xsl:value-of select="concat('rec', $record_num, '_fn', $foot_note_num)"/>
                            </xsl:attribute>
                            <xsl:attribute name="type">foot</xsl:attribute>
                            <xsl:apply-templates/>
                        </xsl:copy>
                    </xsl:when>
                    <xsl:when test="@type='marginale'">
                        <xsl:variable name="marginale_note_num"><xsl:number level="any" format="01"/></xsl:variable>
                        <xsl:variable name="place"><xsl:value-of select="@place"/></xsl:variable>
                        <xsl:copy>
                            <xsl:attribute name="xml:id">
                                <xsl:value-of select="concat('rec', $record_num, '_mn', $marginale_note_num)"/>
                            </xsl:attribute>
                            <xsl:attribute name="type">marginale</xsl:attribute>
                            <xsl:attribute name="place"><xsl:value-of select="$place"></xsl:value-of></xsl:attribute>
                            <xsl:apply-templates/>
                        </xsl:copy>
                    </xsl:when>
                </xsl:choose>
            </xsl:when>
            <xsl:otherwise>
                <xsl:copy>
                    <xsl:apply-templates select="tei:*|@*|text()|processing-instruction()|comment()"/>
                </xsl:copy>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>

</xsl:stylesheet>
