<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet exclude-result-prefixes="#all" version="2.0"
  xmlns:dir="http://apache.org/cocoon/directory/2.0" xmlns:xi="http://www.w3.org/2001/XInclude"
  xmlns:xmt="http://www.cch.kcl.ac.uk/xmod/metadata/files/1.0"
  xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <xsl:param name="document-id" />
  <xsl:param name="record-id" />

  <xsl:template match="/">
    <entity-record document-id="{$document-id}"
      entity-key="{/aggregation/response/result/doc/arr[@name = 'entity_key']/str[1]}"
      entity-name="{/aggregation/response/result/doc/str[@name = 'document_title']}"
      record-id="{$record-id}">
      <navigation>
        <xsl:variable name="id" select="concat($document-id, '::', $record-id)" />

        <xsl:for-each select="/aggregation/response/result/doc/arr[@name = 'occurrence']">
          <xsl:if test="str[starts-with(., $id)]/preceding-sibling::str">
            <xsl:variable name="occurrence"
              select="tokenize(str[starts-with(., $id)]/preceding-sibling::str[1], '::')" />
            <prev document-id="{$occurrence[1]}" record-id="{$occurrence[2]}" />
          </xsl:if>
          <xsl:if test="str[starts-with(., $id)]/following-sibling::str">
            <xsl:variable name="occurrence"
              select="tokenize(str[starts-with(., $id)]/following-sibling::str[1], '::')" />
            <next document-id="{$occurrence[1]}" record-id="{$occurrence[2]}" />
          </xsl:if>
        </xsl:for-each>
      </navigation>
      <tei>
        <xsl:variable name="path" select="/aggregation/files/xmt:file[@xml:id = $document-id]/@path" />
        <xi:include href="cocoon://internal/tei/preprocess/{replace($path, '.html', '.xml')}" />
      </tei>
    </entity-record>
  </xsl:template>
</xsl:stylesheet>
