<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet exclude-result-prefixes="#all" version="2.0"
  xmlns:xi="http://www.w3.org/2001/XInclude" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <xsl:param name="params" />

  <!-- Creates a Solr query. -->
  <xsl:template match="/">
    <search>
      <facets>
        <xi:include>
          <xsl:attribute name="href">
            <xsl:text>cocoon://_internal/solr/query/q=document_type:record&amp;rows=0</xsl:text>
            <xsl:if test="$params">
              <xsl:text>&amp;</xsl:text>
              <xsl:value-of select="$params" />
            </xsl:if>
            <xsl:text>&amp;facet.mincount=1&amp;facet=on</xsl:text>
            <xsl:for-each
              select="/response/lst/lst[@name = 'facet_fields']/lst[@name = 'entity_type']/int">
              <xsl:if test=". > 0 and @name = ('man', 'place_built',
                'place_court', 'place_playing', 'place_region',
                'place_religion', 'place_settlement', 'place_sub_settlement',
                'play_title', 'troupe', 'woman')">
                <xsl:text>&amp;facet.field=</xsl:text>
                <xsl:value-of select="concat(@name, '_entity')" />
              </xsl:if>
            </xsl:for-each>
          </xsl:attribute>
        </xi:include>
      </facets>
      <results>
        <xi:include>
          <xsl:attribute name="href">
            <xsl:text>cocoon://_internal/solr/query/q=document_type:record&amp;rows=15&amp;sort=year_sort+asc</xsl:text>
            <xsl:if test="$params">
              <xsl:text>&amp;</xsl:text>
              <xsl:value-of select="$params" />
            </xsl:if>
          </xsl:attribute>
        </xi:include>
      </results>
    </search>
  </xsl:template>
</xsl:stylesheet>
